#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <alloc.h>
#include <mem.h>

#define PORT_DATA     Base    // Data register port 0x378        Pin 2-9

#define PORT_STAT     Base+1  // Status register port 0x379      Pin
#define ERROR         0x08   // 訡 ਭ                   15
#define SELECT        0x10   // ਭ on-line                   13
#define PE            0x20   // 1 - Paper end  -  㬠       12
#define ACK           0x40   // . ਥ ᨬ             10
#define BUSY          0x80   // ਭ  -   ! 11

#define PORT_CTRL     Base+2  // Ctrl register port 0x37a
#define DIRECTION_IN     0x20 // ࠢ 8 : 1 - 室, 0 - 室
#define ACK_ENABLE    0x10  // 1 - 襭 뢠 ਭ
#define SELECT_IN     0x08
#define INIT          0x04
#define AUTOFD        0x02
#define STROBE        0x01

#define DATAIN  outp(PORT_CTRL, (inp(PORT_CTRL) | 0x20) ) // set 8bit Data input
#define DATAOUT outp(PORT_CTRL, (inp(PORT_CTRL) & 0xdf) ) // set 8bit Data output



static int Base=0x378; // 砫   ⮢ LPT1:
static unsigned char PortCtrl,PortData;

int GetLPTBase(int LPTNo){
// 㭪 砥   ࠫ쭮   ࠭ ஬
// , LPTNo=1 => return = 0x378 ( ࠢ)
   return *( (int*)MK_FP( 0x40,0x06+(LPTNo<<1) ) );
   }

#define OutCtrl() outportb(PORT_CTRL,PortCtrl);
#define OutData() outportb(PORT_DATA,PortData);

void main(int _argc, char *_argv[]){
   FILE* file;
   char filename[40];

   if(_argc!=2){
      printf("\nணࠬ ।祭    LPT1:    ஫  ()DVK.\n"
      " 12 LPT1 砥  뢮 3 (CD) ,  13 -  뢮 4 (TD).\n"
//      "\n -   ! (᫥ ⠭   ⥭)\n"
      " ࠭  䠩   .\n\n맮: MOTOR_IN [<filename>]\n  䠩 (Ctrl-C - 室):");
      scanf("%s",filename);
      }
   else{
      strcpy(filename, _argv[1]);
      }
   file=fopen(filename, "rt");
   if(file!=NULL){
      fclose(file);
      printf("\n 䠩 㦥 ! ९?(ENTER/ESC)\n");
      if(getch()==27)
	 return;
      }
   file=fopen(filename,"wt");
   if(file==NULL){
      printf("訡  䠩 %s!\n",filename);
      return;
      }
   Base=GetLPTBase(1);

   int nWordsRx = 0;
   unsigned int* pData = (unsigned int*)malloc(10000 * sizeof(unsigned int) );
   if(!pData)
   {
      printf("\n訡 ࠧ饭 !\n");
      return;
   }

//   DATAIN; //  -  室!
//   printf("\n   ⥫䮭...\n");
   printf("\n    ᪠ (ESC - 室)...\n");
   if(getch()==27){
      fclose(file);
      return;
      }

   printf("\n ... (室 -  )\n");

   unsigned int Rd = 0;
   int Start=0;
   int NextBit = 0; // ਧ ᫥饣 

   while(!kbhit()){
      unsigned char bt = inportb(PORT_STAT);
      unsigned char Byte = 0;

      if(bt & SELECT)
         Byte = 2;
      if(bt & PE)
         Byte |= 1;

      if(Start){
         switch(Byte){
            case 0: //  
               Start = 0;
	       pData[nWordsRx++] = Rd;
	       printf("%d:\t%u\t=\t%04Xh\n", nWordsRx-1, Rd, Rd); //  ࠭
               Rd = 0;

               if(nWordsRx > 10000) // error
                  return;
               break;

            case 1:
            case 2:
               if(NextBit == 20){ // প  15-50 ? ⮡  ᯮ
                  Rd <<=1; // ᤢ ᭠砫, ⮡   
                  if(Byte == 1) // ⮣  =1
                     Rd |= 1;//  0
                  NextBit = 0; //   ண
                  }
               else if(NextBit) //  প
                  NextBit++;
               break;

            case 3:
               NextBit = 1; // ஬⮪  ⠬
               break;
            }
         } // if (Start)
      else{
         if(Byte == 3)
            Start = 1;
         }
      } //while(!kbhit())

   if(!getch())
      getch();

//   printf("\n⪫ ⥫䮭      !\n");
//   if(!getch())
//      getch();

//   DATAOUT; //  -  室!

   printf("\n 䠩...\n");

   for(int i=0; i<nWordsRx; i++){
      fprintf(file, "%u\n", pData[i]);
      }

   fclose(file);
   free(pData);
   pData = NULL;

   printf("\n %s ᠭ.\n", filename);
   }
